;========================================================
;code and calculations for FLY cheat
;========================================================
MovePlayerForward_Fast:
	;ecx=pointer to 3 facing values x,y,z
;pidivtwo -> pi/2 in DWORD float value (multiply by facingangle for radian)

	fld DWORD [ecx+8]	;z facing value
	fmul [pidivtwo] 	;convert to radian
	fld st0 		;save radian
	fsin
	fmul [UseFlySpeed_Fast]
	fadd [LastZPostion_FLY]
	fstp [LastZPostion_FLY]

	fcos
	fmul [UseFlySpeed_Fast] ;now on x-y plane
	fabs			;must be positive

	fld DWORD [ecx] 	;X facing value
	fmul [pidivtwo]
	fsin
	fmul st0,st1
	fadd DWORD [LastXPostion_FLY]
	fstp DWORD [LastXPostion_FLY]

	fld DWORD [ecx+4]	;Y facing value
	fmul [pidivtwo]
	fsin
	fmul st0,st1
	fadd [LastYPostion_FLY]
	fstp [LastYPostion_FLY]
	fstp st0
ret
;========================================================
MovePlayerForward_Slow:
	;ecx=pointer to 3 facing values x,y,z
;pidivtwo -> pi/2 in DWORD float value (multiply by facingangle for radian)

	fld DWORD [ecx+8]	;z facing value
	fmul [pidivtwo] 	;convert to radian
	fld st0 		;save radian
	fsin
	fmul [UseFlySpeed]
	fadd [LastZPostion_FLY]
	fstp [LastZPostion_FLY]

	fcos
	fmul [UseFlySpeed]	;now on x-y plane
	fabs			;must be positive

	fld DWORD [ecx] 	;X facing value
	fmul [pidivtwo]
	fsin
	fmul st0,st1
	fadd DWORD [LastXPostion_FLY]
	fstp DWORD [LastXPostion_FLY]

	fld DWORD [ecx+4]	;Y facing value
	fmul [pidivtwo]
	fsin
	fmul st0,st1
	fadd [LastYPostion_FLY]
	fstp [LastYPostion_FLY]
	fstp st0
ret
;========================================================
MovePlayerBackward:
	;ecx=pointer to 3 facing values x,y,z
;pidivtwo -> pi/2 in DWORD float value (multiply by facingangle for radian)

	fld DWORD [ecx+8]	;z facing value
	fmul [pidivtwo] 	;convert to radian
	fld st0 		;save radian
	fsin
	fmul [UseFlySpeed]
	fsubr [LastZPostion_FLY]
	fstp [LastZPostion_FLY]

	fcos
	fmul [UseFlySpeed]	;now on x-y plane
	fabs			;must be positive

	fld DWORD [ecx] 	;X facing value
	fmul [pidivtwo]
	fsin
	fmul st0,st1
	fsubr DWORD [LastXPostion_FLY]
	fstp DWORD [LastXPostion_FLY]

	fld DWORD [ecx+4]	;Y facing value
	fmul [pidivtwo]
	fsin
	fmul st0,st1
	fsubr [LastYPostion_FLY]
	fstp [LastYPostion_FLY]
	fstp st0
ret
;========================================================
MovePlayerSidewaysLeft:
	;ecx=pointer to 3 facing values x,y,z

	fld DWORD [ecx+4]	  ;Y facing value
	fmul [pidivtwo]
	fsin
	fmul [UseFlySpeed]
	fsubr DWORD [LastXPostion_FLY]
	fstp DWORD [LastXPostion_FLY]

	fld DWORD [ecx]       ;X facing value
	fmul [pidivtwo]
	fsin
	fmul [UseFlySpeed]
	fadd [LastYPostion_FLY]
	fstp [LastYPostion_FLY]
ret

;========================================================
MovePlayerSidewaysRight:
	;ecx=pointer to 3 facing values x,y,z

	fld DWORD [ecx+4]	  ;Y facing value
	fmul [pidivtwo]
	fsin
	fmul [UseFlySpeed]
	fadd DWORD [LastXPostion_FLY]
	fstp DWORD [LastXPostion_FLY]

	fld DWORD [ecx]       ;X facing value
	fmul [pidivtwo]
	fsin
	fmul [UseFlySpeed]
	fsubr [LastYPostion_FLY]
	fstp [LastYPostion_FLY]
ret
;========================================================
MovePlayerUp:
	fld [LastZPostion_FLY]
	fadd [UseFlySpeed]
	fstp [LastZPostion_FLY]
ret
;========================================================
MovePlayerDown:
	fld [LastZPostion_FLY]
	fsub [UseFlySpeed]
	fstp [LastZPostion_FLY]
ret
;========================================================
