;===============================================================
;WM_KEYDOWN message/key handler code
;===============================================================
;this code is used to disable certain keys' disabling and to
;test if we are in-game, in menu, at console, etc.

KEYDOWNHANDLERPROC:
	mov eax,[esp+1Ch]	;REPLACED CODE
	mov edx,[esp+18h]

	cmp edx,VK_ESCAPE
	    jz Keydown_ESC_Press
	cmp edx,VK_F1
	    jz Keydown_F1_Press
	cmp edx,VK_F11
	    jz Keydown_F11_Press
mov edx,eax		;REPLACED CODE
ret

;===============================================================
Keydown_ESC_Press:
	and [IsInConsole_BOOL],0
	and [IsInGame_BOOL],0
mov edx,eax		;REPLACED CODE
ret
;===============================================================
Keydown_F1_Press:
	and [IsInGame_BOOL],0
mov edx,eax		;REPLACED CODE
ret
;===============================================================
Keydown_F11_Press:
	and [IsInConsole_BOOL],0
mov edx,eax		;REPLACED CODE
ret
;===============================================================
;===============================================================
CONSOLE_OPEN_KEYS_PRESSED:	;if CTRL is pressed,
cmp [IsInGame_BOOL],0		;usually follows Keydown_F11_Press
    jz NO_CONSOLE_OPEN_KEYS_PRESSED
xor [IsInConsole_BOOL],1	;"or" should work as well, but to be safe...
NO_CONSOLE_OPEN_KEYS_PRESSED:

mov ecx,[esi+38h]	 ;REPLACED CODE
mov eax,[ecx]		 ;REPLACED CODE
call DWORD [eax+28h]	 ;REPLACED CODE
ret
;===============================================================