;============================================================
;MAIN CHEAT CODE LAUNCHER (ONCE PROPERLY ADDRESSED IN EXECUTABLE)
;============================================================
;this first part differs from the EXE's interpretation, but because
;the compiler ordered the functions' indexes, there's no point in
;overcomplicating it

;edi=index into DWORD -> usually tested past a certain value by
;the EXE, but it doesn't go that far. The only exception is the "dinos"
;cheat which would crash the game if used in this matter; however, it
;is modified in the initialization.

FOUNDVALIDCONSOLEINPUT:
	jmp DWORD [4*edi+CHEATJUMPINDEX]	;cede control to proper cheat
;===========================================================
EXITCHEATCODE:
	pop edi        ;if no cheats or if cheat index overruns index
	pop esi
	pop ebp
	or al,1
	pop ebx        ;don't know how the return value should be
	add esp,3Ch    ;exactly set, but if no cheat is found,
	ret	       ;0 is returned so...
;===========================================================
include 'TESTCHEATCODE.inc'
;===========================================================
DISPLAYOLDLOCCHEAT:	;set/unset LOC cheat variable
	xor [USE_LOC],1
jmp EXITCHEATCODE
;===========================================================
DISPLAYMAPCONSOLE:	;set/unset MAP cheat variable
	xor [USE_MAP],1
jmp EXITCHEATCODE
;===========================================================
DISPLAYCOUNTER:
	xor [USE_COUNTER],1
jmp EXITCHEATCODE
;===========================================================
RESETCOUNTER:
	invoke GetTickCount
	mov [FirstTimeStamp],eax
jmp EXITCHEATCODE
;===========================================================
BIONICWOMAN_MAIN:
	mov esi,[BaseData]
	mov edx,[GameSpeedVarADDR]
	mov eax,[edx]

	cmp eax,[NormalGameSpeed]
	    jz SetSlowSpeed_BIONIC
	mov eax,[NormalGameSpeed]
	mov [edx],eax
jmp EXITCHEATCODE

SetSlowSpeed_BIONIC:
	mov eax,[DefaultSlowSpeed]
	mov [edx],eax
jmp EXITCHEATCODE
;===========================================================
DINOS_MAIN:
	mov esi,[BaseData]
	mov eax,[DINOS_OBJECT]	;also main "AI System" object
	mov edx,[eax]
	xor BYTE [edx+52h],1	;freeze dinos bool
jmp EXITCHEATCODE
;===========================================================
WOO_MAIN:			;for demo EXE only
	mov esi,[BaseData]
	mov eax,[WOO_AMMO_BOOL_ADDR]
	xor BYTE [eax],1
jmp EXITCHEATCODE
;===========================================================
INVUL_EXPERIMENTAL_MAIN_PROC:
	mov esi,[BaseData]
	mov eax,[PLAYER_OBJ_INVUL_ADDR]
	mov edx,[eax]		;edx = main "Player" class object
	xor BYTE [edx+0DDh],1
ret

INVUL_EXPERIMENTAL_MAIN:
	call INVUL_EXPERIMENTAL_MAIN_PROC
jmp EXITCHEATCODE
;===========================================================
DISPLAYDINOINFO:
	xor [DisplayDinoInfo_BOOL],1
jmp EXITCHEATCODE
;===========================================================
CYCLEDINOINFOLEFT:
	call CYCLEDINOINFOLEFT_PROC
jmp EXITCHEATCODE

CYCLEDINOINFOLEFT_PROC:
	push eax
	mov eax,[DisplayDino_INDEX]
	test eax,eax
	     jz Leftwrap1
	sub eax,4
	mov [DisplayDino_INDEX],eax
	pop eax
	ret

	Leftwrap1:
	mov eax,[CAnimal_BUF_SIZE]
	test eax,eax
	     jz NoCycle_CAnimal_Info_Left
	sub eax,4
	mov [DisplayDino_INDEX],eax
	NoCycle_CAnimal_Info_Left:
	pop eax
	ret
;===========================================================
CYCLEDINOINFORIGHT:
	call CYCLEDINOINFORIGHT_PROC
jmp EXITCHEATCODE

CYCLEDINOINFORIGHT_PROC:
	push eax
	mov eax,[DisplayDino_INDEX]
	add eax,4
	cmp eax,[CAnimal_BUF_SIZE]
	    jnb Rightwrap1
	mov [DisplayDino_INDEX],eax
	pop eax
	ret

	Rightwrap1:
	and [DisplayDino_INDEX],0
	pop eax
	ret
;===========================================================
KILLACTIVEDINO:
	mov ecx,[DisplayDino_INDEX]
	mov eax,[CAnimal_BUF]
	test eax,eax
	     jz EXITCHEATCODE
	mov ebx,[eax+ecx]		;ebx=CAnimal instance
	mov DWORD [ebx+50h],0
jmp EXITCHEATCODE
;===========================================================
KILLALLDINOS:
	mov edx,[CAnimal_BUF]
	test edx,edx
	     jz EXITCHEATCODE
	mov ecx,[CAnimal_BUF_SIZE]
	sub ecx,4
	     jb EXITCHEATCODE

	KillAll_Loop_3243:
	mov eax,[edx+ecx]
	mov DWORD [eax+50h],0
	sub ecx,4
	    jnb KillAll_Loop_3243

jmp EXITCHEATCODE
;===========================================================
SHOWDINOSONMAP:
	xor [ShowDinosOnMap_BOOL],1
jmp EXITCHEATCODE
;===========================================================
SHOWACTIVEDINOONMAP:
	xor [ShowActiveDinoOnMap_BOOL],1
jmp EXITCHEATCODE
;===========================================================
HEALACTIVEDINO:
	mov esi,[DisplayDino_INDEX]
	mov eax,[CAnimal_BUF]
	test eax,eax
	     jz EXITCHEATCODE
	mov ebx,[eax+esi]		;ebx=CAnimal instance
	mov eax,[ebx+54h]		;get MaxHitPoints
	mov [ebx+50h],eax		;Set MaxHitPoints

	mov ebp,esp
	sub esp,50

	mov ecx,ebx
	lea eax,[ebp-50]
	mov edx,[ecx]
	push eax
	call DWORD [edx+10h]	;get current location/orientation info

	mov edx,[CAnimal_Initial_Info]
	lea edx,[edx+esi*8+12]	;edx=dino's initial info

	mov eax,[edx]		;set 4 original orientation values for dino
	mov [ebp-50+12],eax	;(to ensure he is able to get up properly if he was killed)
	mov eax,[edx+4]
	mov [ebp-50+16],eax
	mov eax,[edx+8]
	mov [ebp-50+20],eax
	mov eax,[edx+12]
	mov [ebp-50+24],eax

	mov ecx,ebx
	mov edx,[ebx]
	lea eax,[ebp-50]
	push 0
	push eax
	call DWORD [edx+38h]	;set new orientation values

	mov esp,ebp
jmp EXITCHEATCODE
;===========================================================
CHANGEPLAYERTYPE_PROC:	;switches player class AITypes from 0-5/5-0
			;[esp+4]=new AIType (-1 for switch)
push esi
push edi
push edx
	mov esi,[BaseData]
	mov eax,[PLAYER_OBJ_INVUL_ADDR]
	mov edi,[eax]		;edi = main "Player" class

	mov eax,[edi+0ACh]	;eax=first sub-class leading to AIType
	test eax,eax
	     jz EXIT_CHANGEPLAYERTYPE
	mov ecx,[eax+28h]	;ecx=2nd...
	mov edx,[ecx+10h]	;edx= AIType sub-class

	mov al,[esp+16]
	    cmp al,0FFh
		jnz AITypeSetTo_NULL_1
	mov al,[edx+8h] 	;al = AIType value
	    sub al,5
		jz AITypeSetTo_NULL_1
	    mov al,5
	    AITypeSetTo_NULL_1:
	mov [edx+8h],al

	mov eax,[edi+0B0h]	;eax=first sub-class leading to AIType2
	test eax,eax
	     jz EXIT_CHANGEPLAYERTYPE
	mov ecx,[eax+28h]	;ecx=2nd...
	mov edx,[ecx+10h]	;edx= AIType2 sub-class
	mov al,[esp+16]
	    cmp al,0FFh
		jnz AITypeSetTo_NULL_2
	mov al,[edx+8h] 	;al = AIType2 value
	    sub al,5
		jz AITypeSetTo_NULL_2
	    mov al,5
	    AITypeSetTo_NULL_2:
	mov [edx+8h],al

	;note: there is a third first sub-class, but it points to the same
	;      sub-classes as the second first sub-class
EXIT_CHANGEPLAYERTYPE:
pop edx
pop edi
pop esi
ret 4

CHANGEPLAYERTYPE:
	push -1
	call CHANGEPLAYERTYPE_PROC
jmp EXITCHEATCODE
;===========================================================
SHOWPLAYERFACEFLOATS:
	xor [ShowFaceFloats_BOOL],1
jmp EXITCHEATCODE
;===========================================================
ENABLEFLYCHEAT:
	xor [FLY_MODE_BOOL],1
	mov esi,[BaseData]
	mov eax,[PLAYER_OBJ_INVUL_ADDR]
	mov edx,[eax]		;edx = main "Player" class object


	mov eax,[edx+30h]
	mov [LastXPostion_FLY],eax
	mov eax,[edx+34h]
	mov [LastYPostion_FLY],eax
	mov eax,[edx+38h]
	mov [LastZPostion_FLY],eax

	cmp [FLY_MODE_BOOL],1
	    jz Disable_Keys_345345
	and BYTE [edx+0DDh],0FEh
	push 5
	call CHANGEPLAYERTYPE_PROC
	call EnableInGameKeys
jmp EXITCHEATCODE

	Disable_Keys_345345:
	or BYTE [edx+0DDh],1
	push 0
	call CHANGEPLAYERTYPE_PROC
	call DisableInGameKeys

jmp EXITCHEATCODE
;===========================================================