;========================================================
;GENERAL DATA
;========================================================
;(lots of wasted spaced, but the file's not huge anyhow)

StringBuffer:
	times 256   db	    0	  ;storage for EXE name (faster if static)
PathStringSize	    dd	    0

MapsDirBuffer:
	times 256   db	    0
MapsPathSize	    dd	    0

DLLHandle	    dd	    0
_integer	    dd	    "%i",0	  ;for MSVCRT calls (if present)
_float		    dd	    "%f",0
ProcessHandle	    dd	    0
WindowName	    db	    'Trespasser',0
WindowClassName     db	    'DWI - Trespasser',0
VOldProtectCode     dd	    0
VOldProtectData     dd	    0
VOldProtectRData    dd	    0
LogFileName	    db	    'ATX_LOGFILE.txt',0
DLLLoadSuccessBool  dd	    0		;0 for success, 1 for failure

SAVEGAME_STRING     db	    'SAVEGAME.*',0

SETATJUMP:
	db 0Fh,87h,0,0,0,0	;ja DWORD xxxxxxxx
;========================================================
include 'Errors.inc'
;========================================================
DDSurface_Temp	DDSURFACEDESC2		  ;temporarily used

CAnimal_BUF	    dd	    0		  ;holds pointers to all CAnimal objects
CAnimal_BUF_SIZE    dd	    0		  ;size of previous buffer and INDEX buffer
New_CAnimal_BUF     db	    1

CAnimal_Names_INDEX	    dd	    0	  ;list of pointers into next buffer for strings
CAnimal_Names_BUF	    dd	    0
CAnimal_Names_BUF_SIZE	    dd	    0
CAnimal_Initial_Info	    dd	    0

NewLevel_BOOL		    db	    1

;========================================================
;dino location randomizing values
NULL_STRING		db	"NULL",0
FLOAT_RETRIEVE_STRING	db	"%f, %f, %f",0
MAIN_SECTION		db	"Instances",0
ENTRIES_STRING		db	"Entries",0
ENTRY_COUNT		db	"NumberOfENTRYSections",0
INSTANCE_STRING 	db	"Instance%u",0
RESERVE_STRING		db	"Reserve%u",0
ENTRY_STRING		db	"ENTRY%u",0
LOCATION_STRING 	db	"Location%u",0
STAYNEARMAX_STRING	db	"ForceStayNearMax",0
STAYNEAROK_STRING	db	"ForceStayNearOK",0
;========================================================

;for CANIMAL cheat

canimal_title_base	db	"CAnimal Info (%u instances):",0
canimal_title_size	dd	0
canimal_title:
	times 50	db	0
canimal_pos		db	"Location: %.2f, %.2f, %.2f",0
canimal_health		db	"HitPoints: %.2f",0
canimal_maxhealth	db	"MaxHitPoints: %.2f",0
canimal_bravery 	db	"Bravery: %.5f",0

canimal_emos_text_table:
dd canimal_fear,canimal_love,canimal_anger,canimal_curiosity
dd canimal_hunger,canimal_thirst,canimal_fatigue,canimal_pain
   canimal_emos_text_table_end:

canimal_emos_offsets_table:	   ;offsets from main AI class
dd 4h,8h,0Ch,10h
dd 14h,18h,1Ch,20h

canimal_anger		db	"Anger: %.5f",0
canimal_curiosity	db	"Curiosity: %.5f",0
canimal_fatigue 	db	"Fatigue: %.5f",0
canimal_fear		db	"Fear: %.5f",0
canimal_hunger		db	"Hunger: %.5f",0
canimal_love		db	"Love: %.5f",0
canimal_thirst		db	"Thirst: %.5f",0
canimal_pain		db	"Pain: %.5f",0

DisplayDinoInfo_BOOL	db	0
DisplayDino_INDEX	dd	0

ShowDinosOnMap_BOOL		db	0
ShowActiveDinoOnMap_BOOL	db	0

ShowFaceFloats_BOOL		db	0
ShowFaceFloat_STRING		db	"Player face values: %.5f, %.5f, %.5f, %.5f",0
;========================================================

INIname 	    db	    "ATXconfig.ini",0
FileHandleINI	    dd	    0
FileSizeINI	    dd	    0
TempMemINI	    dd	    0
TempVar 	    dd	    0

MapIndex	    db	    "MapIndex.ini",0

;BASE DATA POINTER(S)
BaseData	    dd	    0

;FLAGS/VALUES
UseMXTBITE	    dd	    0
UseWINDOWED	    dd	    0
UseGRAVITY	    dd	    0
UseDRAWDISTANCE     dd	    0
UseTRESSTRDBG	    dd	    0
UseDEMOHACK	    dd	    0
UseNoGetOut	    dd	    0
UseNoStayNear	    dd	    0
UseNoStayAway	    dd	    0
UseSleepWake	    dd	    0
UseDisableSWPDelete dd	    0
UseCAnimalHitPoints dd	    0
UseRandomDinoLocations	    dd	0

UseUserMapKey		    dd	0
UseUserMDinoKey 	    dd	0
UseDrawDistSubKey	    dd	0
UseDrawDistAddKey	    dd	0
UseCANIMALKey		    dd	0
UseUserMSelKey		    dd	0
UseUserCANIMALLEFTKey	    dd	0
UseUserCANIMALRIGHTKey	    dd	0

UseToggleNewKeys	    dd	0
ToggleNewKeys_BOOL	    db	1
ToggleKeys_FORCED_BOOL	    db	0
ToggleKeysShowStateTime     dd	0

SDBGDUMPFILE	    db	    "C:\SDBG_DUMP.txt",0

STRDBG_MAIN_ADDR    dd	    TRES_STR_DBG_MAIN

;========================================================
;================ AT-SPECIFIC VARIABLES

;AT100
LastTimerID	    dd	    0		  ;used to remember last set timer

;AT102
AT102EMULATEDOBJECT:
		    dd	    0
		    dd	    0
		    dd	    0
		    dd	    0
		    dd	    0
		    dd	    0
		    dd	    0
		    dd	    1	;1 for direct BMP name ref (not relative to buffer)

;current bitmap values /*
anchorXvalue	    dd	    0
anchorYvalue	    dd	    0
scaleXvalue	    dd	    0
scaleYvalue	    dd	    0

currentbitmap	    dd	    0
bitmapheight	    dd	    0
bitmapwidth	    dd	    0
;                       */

USE_MAP 	    db	    0
USE_LOC 	    db	    0
NO_LOC_JUMP_ADDR    dd	    0
LOC_MAP_NEW_TEST_CODE_ADDR	dd	LOC_MAP_NEW_TEST_CODE
LastTickCount	    dd	    0
Show_Blinker	    db	    1

SAVED_MAP_BUFFER:
	times 80 db 0

CURRENT_MAP_BUFFER:
	times 80 db 0
CURRENT_MAP_VALUES:
	times 4 dd 0

SAVEGAMENAME_BUFFER:
	times 256 db 0

SAVED_MAP_OBJECT:
		    dd	    0
		    dd	    0
		    dd	    SAVED_MAP_BUFFER
SAVED_MAP_X1	    dd	    0
SAVED_MAP_Y1	    dd	    0
SAVED_MAP_X2	    dd	    0
SAVED_MAP_Y2	    dd	    0
		    dd	    1		;1 for direct BMP name ref

SAVE_SAVED_MAP_STATE_ADDR	dd	SAVE_SAVED_MAP_STATE
LOADINITIALBITMAPCALL		dd	LOADINITIALBITMAP
HINT_PROC_ADDR			dd	HINT_LOADSTRING_CUSTOM
HINT_RETURN_ADDR		dd	0
HINT_NEW_STRING_ADDR		dd	0
KEY_HANDLER_CODE_ADDR		dd	MAIN_KEYHANDLER
KEYDOWN_HANDLER_CODE_ADDR	dd	KEYDOWNHANDLERPROC
CTRL_F11_CODE_ADDR		dd	CONSOLE_OPEN_KEYS_PRESSED

IsInGame_BOOL			db	0
IsInConsole_BOOL		db	0

DrawDistDisplayTime		dd	0
DrawDistDisplayString		db	"Draw Distance: %2f",0

;========================================================
;counter stuff
CounterFirstRun     dd	    0
USE_COUNTER	    dd	    0
FirstTimeStamp	    dd	    0
Time_Format_String  db	    "Time: %-.2u:%-.2u:%-.2u",0

;========================================================
;MXTBITE
MXT_BITE_PTR	    dd	    MXTBite
AT100SimulatedObject:
		    dd	    0
		    dd	    0
DefaultSlowSpeed    dd	    0.300000
DefaultInterval     dd	    4500
		    dd	    0
		    dd	    0

NormalGameSpeed     dd	    0	 ;updated with variable from executable or INI and/or ActionType 100-101

;========================================================
;============= HACKED CONSOLE VARIABLES
Cheattable:
	times (2*80)	dd	0	;extra size for new cheat(s)

STRING_MAP		    db	"MAP",0
STRING_TIME		    db	"TIME",0
STRING_RESET		    db	"RESET",0
STRING_DINOINFO 	    db	"CANIMAL",0
STRING_DINOINFOCYCLELEFT    db	"B",0
STRING_DINOINFOCYCLERIGHT   db	"N",0
STRING_KILLDINO 	    db	"KILL",0
STRING_MDINO		    db	"MDINO",0
STRING_MSEL		    db	"MSEL",0
STRING_HEALDINO 	    db	"HEALDINO",0
STRING_TESTCHEAT	    db	"TEST",0
STRING_CLOAK		    db	"CLOAK",0
STRING_FAC		    db	"FAC",0
STRING_FLY		    db	"FLY",0
STRING_KILLALL		    db	"KILLALL",0

FoundCheatPTR	    dd	FOUNDVALIDCONSOLEINPUT
CheatTablePTR	    dd	Cheattable

MACRO DEFINE_CHEAT cheat1 {
      dd cheat1
      dd 0
      }

NewCheattableMembers:
	DEFINE_CHEAT	  STRING_MAP
	DEFINE_CHEAT	  STRING_TIME
	DEFINE_CHEAT	  STRING_RESET
	DEFINE_CHEAT	  STRING_DINOINFO
	DEFINE_CHEAT	  STRING_DINOINFOCYCLELEFT
	DEFINE_CHEAT	  STRING_DINOINFOCYCLERIGHT
	DEFINE_CHEAT	  STRING_KILLDINO
	DEFINE_CHEAT	  STRING_MDINO
	DEFINE_CHEAT	  STRING_MSEL
	DEFINE_CHEAT	  STRING_HEALDINO
	DEFINE_CHEAT	  STRING_TESTCHEAT
	DEFINE_CHEAT	  STRING_CLOAK
	DEFINE_CHEAT	  STRING_FAC
	DEFINE_CHEAT	  STRING_FLY
	DEFINE_CHEAT	  STRING_KILLALL
EndNewCheattableMembers:

CHEATJUMPINDEX:
	times 80	dd	0

NEWCHEATSINDEX:
	dd	DISPLAYMAPCONSOLE
	dd	DISPLAYCOUNTER
	dd	RESETCOUNTER
	dd	DISPLAYDINOINFO
	dd	CYCLEDINOINFOLEFT
	dd	CYCLEDINOINFORIGHT
	dd	KILLACTIVEDINO
	dd	SHOWDINOSONMAP
	dd	SHOWACTIVEDINOONMAP
	dd	HEALACTIVEDINO
	dd	TESTCHEATCODE
	dd	CHANGEPLAYERTYPE
	dd	SHOWPLAYERFACEFLOATS
	dd	ENABLEFLYCHEAT
	dd	KILLALLDINOS
ENDNEWCHEATSINDEX:

TotalCheats	dd	0
OriginalCheats	dd	0
;========================================================
;FLY MODE VARS

DIVERTED_POS_METHOD	dd	ChangePlayerPosDivertedMethod

float_two		dd	2.000000
UseFlySpeed_Fast	dd	default_fast_fly_speed
UseFlySpeed		dd	default_normal_fly_speed
UseFlyKeyDelay		dd	default_key_fly_delay
pidivtwo		dd	1.5707963267948966192313216916398

FLY_MODE_BOOL		db	0
Key_Last_Recorded_Time	dd	0

LastXPostion_FLY	dd	0	;only these need to be updated
LastYPostion_FLY	dd	0	;when cheat is enabled
LastZPostion_FLY	dd	0

TrueChangePlayerPosMethod	dd	0

Temp_Fly_Buffer:
	times 16 dd 0

Temp_Fly_Buffer2:
	times 8 dd 0

Temp_Fly_Buffer3:
	dd 0
	dd 03F800000h
	dd 0

DefaultKeyBOOLS:	;from "KeyMap" reg key/exe key list
	dd	00000040h
	dd	00000080h
	dd	00000010h
	dd	00000008h
	dd	00000020h
	dd	00000001h
	dd	00000002h
	dd	00000100h
	dd	00000400h
	dd	00000200h
	dd	01000000h
	dd	02000000h
	dd	04000000h
	dd	08000000h
	dd	10000000h
DefaultKeyBOOLS_END:

;========================================================
